package me.armar.plugins.autorank;

import org.bukkit.entity.Player;

public class AutorankUpdateData implements Runnable {

	private Autorank plugin;
	private Player[] onlinePlayers;
	private Config data;
	private Config config;
	private VaultHandler vault;
	private RankChecker rankChecker;

	public AutorankUpdateData(Autorank plugin) {
		this.plugin = plugin;
		this.data = this.plugin.getData();
		this.config = this.plugin.getConf();
		vault = plugin.getVault();
		rankChecker = plugin.getRankChecker();
	}

	@Override
	public void run() {
		onlinePlayers = plugin.getServer().getOnlinePlayers();
		updateMinutesPlayed();
		if ((Boolean) config.get("Automatic rank changes")) {
			updateRanks();
		}
		if ((Boolean) config.get("Log updates")) {
			plugin.logMessage("Updated");
		}
	}

	private void updateMinutesPlayed() {
		for (int i = (onlinePlayers.length - 1); i >= 0; i--) {
			String playerName = onlinePlayers[i].getName().toLowerCase();
			if (!data.exists(playerName)) {
				data.set(playerName, 0);
			}
			if(!onlinePlayers[i].hasPermission("autorank.timeexclude"))
			{
			data.set(playerName,
					((Integer) data.get(playerName) + (Integer) config
							.get("Update interval(minutes)")));
			}
		}
	}

	private void updateRanks() {
		for (int i = (onlinePlayers.length - 1); i >= 0; i--) {
			Player player = onlinePlayers[i];
			String playerName = player.getName();
			String[] playerData = rankChecker.getPlayerData(playerName);
			if (!playerData[0].equals("No upgrade")) {
				vault.setRank(playerName, playerData[1], playerData[2]);
				String message = (String) config
						.get("Rank" + rankChecker.getRankNumber(playerData[2])
								+ ".message");
				if (message != null) {
					player.sendMessage(message);
				} else {
					player.sendMessage("Your rank has been changed to "
							+ playerData[2] + ".");
				}
			}
		}
	}

}